[![Build Status](https://travis-ci.org/ideal-postcodes/ideal-postcodes-core.svg?branch=master)](https://travis-ci.org/ideal-postcodes/ideal-postcodes-core) [![npm version](https://badge.fury.io/js/ideal-postcodes-core.svg)](https://badge.fury.io/js/ideal-postcodes-core) 

# Ideal Postcodes - Frontend Client

## Introduction

This library provides a core set of API's to interact with the Ideal Postcodes API on the browser. 

You may accomplish the following jobs using this library:

- Query addresses for a postcode
- Query for an address with an address fragment
- Autocomplete an address
- Lookup an address by ID
- Check key useability

## Build Status & Browser Compatibility Information

This library is tested across modern desktop and mobile browers

Internet Explorer 9 and above is supported. Internet Explorer 6, 7 and 8 are not supported

## Methods

Please see our [documentation](https://ideal-postcodes.co.uk/documentation/ideal-postcodes-core)

## Installation

You may install it via npm with,

```bash
npm install ideal-postcodes-core --save
```

You may also use Bower with,

```bash
bower install ideal-postcodes-core --save
```

Finally you can install it manually by copying the minified build from `/dist/`

## Testing

Run the test suite with,

```bash
gulp test
```

You may test the library manually in a browser console with,

```bash
gulp webserver
```

## License

MIT
