/**
 * ideal-postcodes-core - Ideal Postcodes core frontend javascript library
 * @version v0.1.2
 * @link https://ideal-postcodes.co.uk/
 * @license MIT
 */

;(function(window, document) {
"use strict";

var __extends=this&&this.__extends||function(t,e){function r(){this.constructor=t}for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o]);t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)},IdealPostcodes;!function(t){var e;!function(t){var e=function(t){function e(e){t.call(this),this.message="Ideal Postcodes Error: "+e.message}return __extends(e,t),e}(Error);t.IdealPostcodesError=e;var r=function(t){function e(){t.call(this,{message:"Unable to parse JSON response"})}return __extends(e,t),e}(e);t.JsonParseError=r}(e=t.Errors||(t.Errors={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(t){t.parse=function(o){var s,u=o.status;if(200!==u){switch(u){case 503:return new r}try{s=JSON.parse(o.responseText)}catch(i){return new t.JsonParseError}var a=s.code,c=s.message;return void 0===a||void 0===c?new n:new e({responseCode:a,status:u,message:c})}};var e=function(t){function e(e){t.call(this,e),e.status&&(this.status=e.status),e.responseCode&&(this.responseCode=e.responseCode)}return __extends(e,t),e}(t.IdealPostcodesError);t.IdealPostcodesApiError=e;var r=function(t){function e(){t.call(this,{status:503,message:"Rate Limit Reached. Please wait a while before you retry your request"})}return __extends(e,t),e}(e);t.RateLimitError=r;var o=function(t){function e(){t.call(this,{message:"Request timed out"})}return __extends(e,t),e}(e);t.RequestTimeoutError=o;var n=function(t){function e(){t.call(this,{message:"Unknown AJAX error occurred when accessing API"})}return __extends(e,t),e}(e);t.GenericApiError=n}(e=t.Errors||(t.Errors={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(e){e.getXhr=function(){try{return new(XMLHttpRequest||ActiveXObject)("MSXML2.XMLHTTP.3.0")}catch(t){return null}},e.detectTls=function(t){try{return"http:"!==t.location.protocol}catch(e){return!0}},e.defaultHeaders={Accept:"text/javascript, application/javascript"},e.generateQueryString=function(t){var e=[];for(var r in t)e.push(encodeURIComponent(r)+"="+encodeURIComponent(t[r]));return e.join("&")};var r=/^\s*$/;e.xhrRequest=function(o,n){var s=o.url,u=o.timeout||t.DEFAULT_TIMEOUT,i=o.data||null,a=t.Utils.extend({},e.defaultHeaders,o.headers||{}),c=o.method||"GET",l=e.generateQueryString(o.queryString||{});l.length>0&&(s+="?"+l);var d=e.getXhr();d.open(c,s,!0);try{for(var p in a)d.setRequestHeader(p,a[p])}catch(h){}var f=setTimeout(function(){d.onreadystatechange=function(){},d.abort(),n(new Error("Request timeout"),null,d)},u);return d.onreadystatechange=function(){var e;if(4===d.readyState){if(clearTimeout(f),200!==d.status)return n(t.Errors.parse(d),{},d);try{e=r.test(d.responseText)?{}:JSON.parse(d.responseText)}catch(o){return n(new Error("parsererror"),null,d)}return n(null,e,d)}},d.send(i),d}}(e=t.Transport||(t.Transport={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){t.API_URL="api.ideal-postcodes.co.uk",t.TLS=!0,t.VERSION="v1",t.DEFAULT_TIMEOUT=1e4,t.STRICT_AUTHORISATION=!1}(IdealPostcodes||(IdealPostcodes={})),window.IdealPostcodes=IdealPostcodes;var IdealPostcodes;!function(t){var e;!function(t){t.extend=function(t){for(var e=[],r=1;r<arguments.length;r++)e[r-1]=arguments[r];for(var o=e.length,n=0;o>n;n++){var s=e[n];for(var u in s)void 0!==s[u]&&(t[u]=s[u])}return t}}(e=t.Utils||(t.Utils={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e=function(){function t(){this.store={postcodeStore:{},addressStore:{},autocompleteStore:{},udprnStore:{},umprnStore:{}}}return t.prototype.cacheAddressQuery=function(t,e){this.store.addressStore[t]=e},t.prototype.getAddressQuery=function(t){return this.store.addressStore[t]},t.prototype.cachePostcodeQuery=function(t,e){this.store.postcodeStore[t]=e},t.prototype.getPostcodeQuery=function(t){return this.store.postcodeStore[t]},t.prototype.cacheAutocompleteQuery=function(t,e){this.store.autocompleteStore[t]=e},t.prototype.getAutocompleteQuery=function(t){return this.store.autocompleteStore[t]},t.prototype.cacheUdprnQuery=function(t,e){this.store.udprnStore[t]=e},t.prototype.getUdprnQuery=function(t){return this.store.udprnStore[t]},t.prototype.cacheUmprnQuery=function(t,e){this.store.umprnStore[t]=e},t.prototype.getUmprnQuery=function(t){return this.store.umprnStore[t]},t}();t.Cache=e}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(t){var e=function(){return Date.now()};t.debounce=function(t,r){function o(){var c=e()-i;c>0&&r>c?n=setTimeout(o,r-c):(n=null,a=t.apply(u,s),n||(u=s=null))}void 0===r&&(r=100);var n,s,u,i,a;return function(){return u=this,s=arguments,i=e(),n||(n=setTimeout(o,r)),a}}}(e=t.Utils||(t.Utils={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e;!function(t){t.AllowedAuthorizationParameters=["api_key"],t.constructHeaders=function(e){var r={};return r.Authorization=t.constructAuthenticationHeader(e),r},t.constructAuthenticationHeader=function(e){for(var r=[],o=0;o<t.AllowedAuthorizationParameters.length;o++){var n=t.AllowedAuthorizationParameters[o];void 0!==e[n]&&r.push(n+'="'+e[n]+'"')}return 0===r.length?"":"IDEALPOSTCODES "+r.join(" ")},t.constructQueryString=function(t){var e={};return t.filter&&(e.filter=t.filter.join(",")),t.licensee&&(e.licensee=t.licensee),t.tags&&(e.tags=t.tags.join(",")),e},t.constructAutocompleteQueryString=function(t){var e={};return e.query=t.query,e},t.constructAddressQueryString=function(t){var e={};return e.query=t.query,e.page=t.page||0,e.limit=t.limit||10,e}}(e=t.XhrUtils||(t.XhrUtils={}))}(IdealPostcodes||(IdealPostcodes={}));var IdealPostcodes;!function(t){var e=t.Utils.extend,r=t.XhrUtils.constructHeaders,o=t.XhrUtils.constructQueryString,n=t.XhrUtils.constructAddressQueryString,s=t.XhrUtils.constructAutocompleteQueryString,u=function(){function u(e){var r=this;void 0===e&&(e={}),this.api_key=e.api_key,this.tls=void 0===e.tls?t.TLS:e.tls,this.version=void 0===e.version?t.VERSION:e.version,this.baseUrl=void 0===e.baseUrl?t.API_URL:e.baseUrl,this.strictAuthorisation=void 0===e.strictAuthorisation?t.STRICT_AUTHORISATION:e.strictAuthorisation,this.cache=new t.Cache;var o=this;this.autocompleteCallback=function(){},this.debouncedAutocomplete=t.Utils.debounce(function(t){r.lookupAutocomplete(t,o.autocompleteCallback)})}return u.prototype.apiUrl=function(){return"http"+(this.tls?"s":"")+"://"+this.baseUrl+"/"+this.version},u.prototype.ping=function(e){t.Transport.xhrRequest({url:"http"+(this.tls?"s":"")+"://"+this.baseUrl},e)},u.prototype.lookupPostcode=function(e,n){var s=this;e.api_key=this.api_key;var u=r(e),i=o(e),a=e.postcode,c=this.cache.getPostcodeQuery(a);return c?n(null,c):void t.Transport.xhrRequest({url:this.apiUrl()+"/postcodes/"+encodeURIComponent(e.postcode),headers:u,queryString:i},function(t,e,r){return t&&4040===t.responseCode?n(null,[],r):t?n(t,null,r):(s.cache.cachePostcodeQuery(a,e.result),n(null,e.result,r))})},u.prototype.lookupAddress=function(s,u){var i=this;s.api_key=this.api_key;var a=r(s),c=o(s);e(c,n(s));var l=s.query,d=this.cache.getAddressQuery(l);return d?u(null,d):void t.Transport.xhrRequest({url:this.apiUrl()+"/addresses",headers:a,queryString:c},function(t,e,r){return t?u(t,null,r):(i.cache.cacheAddressQuery(l,e.result),u(null,e.result,r))})},u.prototype.lookupAutocomplete=function(n,u){var i=this;n.api_key=this.api_key;var a=r(n),c=o(n);e(c,s(n));var l=n.query,d=this.cache.getAutocompleteQuery(l);return d?u(null,d):(this.strictAuthorisation||(c.api_key=this.api_key,delete a.Authorization),void t.Transport.xhrRequest({url:this.apiUrl()+"/autocomplete/addresses",headers:a,queryString:c},function(t,e,r){return t?u(t,null,r):(i.cache.cacheAutocompleteQuery(l,e.result),u(null,e.result,r))}))},u.prototype.lookupUdprn=function(e,n){var s=this;e.api_key=this.api_key;var u=r(e),i=o(e),a=e.id,c=this.cache.getUdprnQuery(a);return c?n(null,c):void t.Transport.xhrRequest({url:this.apiUrl()+"/udprn/"+a,headers:u,queryString:i},function(t,e,r){return t?n(t,null,r):(s.cache.cacheUdprnQuery(a,e.result),n(null,e.result,r))})},u.prototype.lookupUmprn=function(e,n){var s=this;e.api_key=this.api_key;var u=r(e),i=o(e),a=e.id,c=this.cache.getUmprnQuery(a);return c?n(null,c):void t.Transport.xhrRequest({url:this.apiUrl()+"/umprn/"+a,headers:u,queryString:i},function(t,e,r){return t?n(t,null,r):(s.cache.cacheUmprnQuery(a,e.result),n(null,e.result,r))})},u.prototype.checkKeyUsability=function(e){t.Transport.xhrRequest({url:this.apiUrl()+"/keys/"+this.api_key},function(t,r,o){return t?e(t,null,o):e(null,r.result,o)})},u.prototype.autocompleteAddress=function(t){this.debouncedAutocomplete(t)},u.prototype.registerAutocompleteCallback=function(t){this.autocompleteCallback=t},u}();t.Client=u}(IdealPostcodes||(IdealPostcodes={}));
}(window, document));
